Subject: [Netmod-ver-dt] [rgwilton/YANG-Packages-Draft] 6ac8c3: remove test.txt again

From: Robert Wilton <[email-masked]>
Date: Thu, 03 Oct 2019 07:21:58 -0700

Branch: refs/heads/master
  Home:   https://github.com/rgwilton/YANG-Packages-Draft
  Commit: 6ac8c3e1af22f5ddf96337b98115bb173a8e900c
      https://github.com/rgwilton/YANG-Packages-Draft/commit/6ac8c3e1af22f5ddf96337b98115bb173a8e900c
  Author: rwilton <[email-masked]>
  Date:   2019-09-12 (Thu, 12 Sep 2019)

  Changed paths:
    R test.txt

  Log Message:
  -----------
  remove test.txt again

  Commit: 88d11ad88541b5edb2944d6d2d3d7a318c7f06d0
      https://github.com/rgwilton/YANG-Packages-Draft/commit/88d11ad88541b5edb2944d6d2d3d7a318c7f06d0
  Author: rwilton <[email-masked]>
  Date:   2019-10-03 (Thu, 03 Oct 2019)

  Changed paths:
    M draft-rwilton-netmod-yang-packages.txt
    M draft-rwilton-netmod-yang-packages.xml
    M ietf-yang-package-types.yang
    M ietf-yang-package.yang
    M ietf-yl-packages.yang
    A tmp/ietf-datastores.yang
    A tmp/[email-masked]
    A tmp/ietf-origin.yang
    A tmp/ietf-yang-library-packages.yang
    A tmp/ietf-yang-library.yang
    A tmp/ietf-yang-package-types.yang
    A tmp/ietf-yang-package.yang
    A tmp/ietf-yang-revisions.yang
    A tmp/[email-masked]
    A tmp/ietf-yl-packages.yang

  Log Message:
  -----------
  updated packages draft

Compare: https://github.com/rgwilton/YANG-Packages-Draft/compare/4f4c7c1a4029...88d11ad88541

---

From: "Rob Wilton (rwilton)" <[email-masked]>
Date: Thu, 3 Oct 2019 15:31:28 +0000

Joe asked me if he could take a look at the current version of the packages work, so I just uploaded where I am at.

I'm still working on updating the document.  I think that the YANG modules are pretty close to what they should be, but I need to put further fixes in the current examples, and make further updates to the text.

There is also quite a long list of Open github issues (https://github.com/rgwilton/YANG-Packages-Draft/issues), many of which I'm in the process of addressing, but want to update the DT with how I have addressed them in the draft so that I can get rid of them when the next version of the draft is published, so that what remains are truly the open issues.

Thanks,
Rob

> -----Original Message-----
> From: Netmod-ver-dt <[email-masked]> On Behalf Of Robert
> Wilton
> Sent: 03 October 2019 15:22
> To: [email-masked]
> Subject: [Netmod-ver-dt] [rgwilton/YANG-Packages-Draft] 6ac8c3: remove
> test.txt again
> 
>       https://github.com/rgwilton/YANG-Packages-
> Draft/commit/6ac8c3e1af22f5ddf96337b98115bb173a8e900c
>       https://github.com/rgwilton/YANG-Packages-
> Draft/commit/88d11ad88541b5edb2944d6d2d3d7a318c7f06d0
> Compare: https://github.com/rgwilton/YANG-Packages-
> Draft/compare/4f4c7c1a4029...88d11ad88541
> 
> _______________________________________________
> Netmod-ver-dt mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/netmod-ver-dt

---

From: Mahesh Jethanandani <[email-masked]>
Date: Tue, 15 Oct 2019 17:35:24 -0700

Hi Rob,

I started to review the draft a few days ago, but never really got to finishing them or even to sent out the comments I had collected. I see a few reviews since, so some of these comments might come across as duplicates. Use them as fit.

Comments on the (not so) latest version of the draft. Mostly nits.

Section 2

s/YANG modules the provide the definitions for YANG package/YANG modules that provide the definitions for YANG package/

Section 3.

I think the realization is beyond the IETF NETMOD community. I would

s/within the IETF NETMOD/within the IETF NETMOD and broader/

Section 4.

First bullet item.

Is a YANG package a ‘set of modifications’ or ‘additional modules'? I would think that a YANG package is a set of modules, deviations and/or features.

Fourth bullet item.

s/the problem were a/the problem where a/
s/or impossible/if not impossible/

Second last paragraph

s/are be used/are to be used/

Section 5.1

This and the previous rule brings up an interesting scenario:

      The version/revision of a module listed in the package module list
      supercedes any version/revision of the module listed in a imported
      package module list.  This allows a package to resolve any
      conflicting implemented module versions/revisions in imported
      packages.

If a module A imports module B with revision 1.1.1, but the package defines the revision of the module B as 2.0.0, because module C needs that revision. That version of module B has NBC in it. By having this rule, we are essentially breaking interoperability between module A and module B. Why are we insisting that a package MUST have a single revision of the module? What would be wrong in having both revision of module B be part of the same package?

Cheers.

> On Oct 3, 2019, at 7:21 AM, Robert Wilton <[email-masked]> wrote:
> 

Mahesh Jethanandani
[email-masked]

---

From: "Rob Wilton (rwilton)" <[email-masked]>
Date: Wed, 16 Oct 2019 17:09:35 +0000

Hi Mahesh,

Thanks for the comments.  Please see inline ...

> From: Netmod-ver-dt <[email-masked]> On Behalf Of Mahesh
> Jethanandani
> Sent: 16 October 2019 01:35
> To: Robert Wilton <[email-masked]>
> Cc: [email-masked]
> Subject: Re: [Netmod-ver-dt] [rgwilton/YANG-Packages-Draft] 6ac8c3: remove
> test.txt again
> 
> Hi Rob,
> 
> I started to review the draft a few days ago, but never really got to
> finishing them or even to sent out the comments I had collected. I see a
> few reviews since, so some of these comments might come across as
> duplicates. Use them as fit.
> 
> s/YANG modules the provide the definitions for YANG package/YANG modules
> that provide the definitions for YANG package/
> 
[RW] 
I couldn't find this one, so perhaps already fixed.

> s/within the IETF NETMOD/within the IETF NETMOD and broader/
[RW] 
I've already tweaked this as per Joe's suggestion.

> Section 4.
> 
> First bullet item.
> 
> Is a YANG package a ‘set of modifications’ or ‘additional modules'? I
> would think that a YANG package is a set of modules, deviations and/or
> features.
[RW] 
I suspect the text has changed.  The current definition is:

   A YANG package is a versioned organizational structure holding a set
   of related YANG modules, packages, features, and deviations.  A YANG
   package collectively define a YANG schema.

> 
> Fourth bullet item.
> 
> s/the problem were a/the problem where a/ s/or impossible/if not
> impossible/
[RW] 
OK.

> s/are be used/are to be used/
[RW] 
OK.

> If a module A imports module B with revision 1.1.1, but the package
> defines the revision of the module B as 2.0.0, because module C needs that
> revision. That version of module B has NBC in it. By having this rule, we
> are essentially breaking interoperability between module A and module B.
> Why are we insisting that a package MUST have a single revision of the
> module? What would be wrong in having both revision of module B be part of
> the same package?
[RW] 
YANG only allows a single revision of a module to be implemented (RFC 7950, sec 5.6.5, 2nd paragraph).  This rule effectively also applies to a schema that is being constructed.

So, I think that it is OK if both revisions of module B are import-only, or only one revision is implemented.  But it is not OK if both revisions need to be implemented.

I think that it is probably unwise to import a specific revision of a module, unless the import is only required to reference types.

Thanks for the comments,
Rob

> > Compare:
> > https://github.com/rgwilton/YANG-Packages-Draft/compare/4f4c7c1a4029..
> > .88d11ad88541
> >